import greenfoot.*;  
import java.util.List;
import java.util.ArrayList;
public class MyWorld extends World
{
    public int WaveNumber = 0;
    private int random;
    private int TimeToNextWave = 10;
    private int rate=50;
    private int TimeToSpawn=120;
    public int Money=50;
    public MyWorld()
    {    
        super(600, 600, 1);
        addObject(new Road(0), 25, 25);
        addObject(new Road(0), 75, 25);
        addObject(new Road2(), 125, 25);
        addObject(new Road(1), 125, 75);
        addObject(new Road(1), 125, 125);
        addObject(new Road(1), 125, 175);
        addObject(new Road3(), 125, 225);
        addObject(new Road(0), 175, 225);
        addObject(new Road(0), 225, 225);
        addObject(new Road(0), 275, 225);
        addObject(new Road(0), 325, 225);
        addObject(new Road2(), 375, 225);
        addObject(new Road(1), 375, 275);
        addObject(new Road3(), 375, 325);
        addObject(new Road(0), 425, 325);
        addObject(new Road4(), 475, 325);
        addObject(new Road(1), 475, 275);
        addObject(new Road(1), 475, 225);
        addObject(new Road(1), 475, 175);
        addObject(new Road2(), 475, 125);
        addObject(new Road(0), 425, 125);
        addObject(new Road(0), 375, 125);
        addObject(new Road(0), 325, 125);
        addObject(new Road3(), 275, 125);
        addObject(new Road(1), 275, 75);
        
        showText("Money: "+Money, 50, 550);
        showText("Buy Tower", 550, 510);
        addObject(new Buybutton(), 550, 550);
         
        Castle castle=new Castle(5);
        addObject(castle, 275, 56);
        showText("Health: "+5, 50, 500);
        showText("Cost: "+20, 550, 580);
        addObject(new Cannon(), 300, 560);
    }
    public void act() 
    {
       
      TimeToNextWave--;
      TimeToSpawn++;
      Spawn();
      if(TimeToNextWave  < 1 )
      {
       NextWave();
       
      }
      

    }    
    public void Spawn()
    {
        if(TimeToSpawn % rate ==0 && TimeToSpawn<rate*3+WaveNumber*(rate/2))
        {
            random=Greenfoot.getRandomNumber(100+WaveNumber*4);
            if(random<100-WaveNumber*9){
              addObject(new enemy1(), 25, 25);
            }
            else if(random<110-WaveNumber*3){
              addObject(new enemy2(), 25, 25);
            } 
            else if(random<170-WaveNumber*2){
              addObject(new enemy3(), 25, 25);  
            }
            else{
              addObject(new enemy4(), 25, 25);
            }
        }
    
    } 
    public void NextWave()
    {
        WaveNumber++;
        TimeToNextWave = 750 + WaveNumber * 75;
        TimeToSpawn=0;
        rate = 55+Greenfoot.getRandomNumber(75);
        showText("Wave: "+WaveNumber, 550, 20);
    }
        public int getWaveNumber()
    {
        return WaveNumber;
    }
        public int getMoney()
    {
        return Money;
    }
        public void MoneyChange(int money)
    {
         Money+=money;
         showText("Money: "+Money, 50, 550);
    }
}
